var MQTT = {};
var client; 
var reconnectInterval = 15000; 
var isReconnecting = false; 

MQTT.connect = function () {
  var config = Config.get("config");
  var topic = "device_" + config.tag;
  var clientID = "client_" + config.tag + "_" + Math.random().toString(16);

  client = new Paho.MQTT.Client("mqtt.octoservice.net", 8083, clientID);

  client.connect({
    cleanSession: true,
    mqttVersion: 4,
    userName: "client",
    password: "KGUhEtIuPcS2kN0H",
    onSuccess: function (response) {
      client.subscribe(topic, {
        qos: 0,
        onSuccess: function () {
          log("MQTT Subscribe Success");

          if (isReconnecting) {
            log("Reconnected successfully. Reloading page...");
            location.reload(); 
          }
        },
        onFailure: function (error) {
          log("MQTT Subscribe Failed: ");
        },
      });

      isReconnecting = false; 
    },
    onFailure: function (error) {
      
      setTimeout(MQTT.connect, reconnectInterval); 
    },
  });

  client.onConnectionLost = function (responseObject) {
    if (responseObject.errorCode !== 0) {
      log("MQTT connection lost: " + responseObject.errorMessage);
      isReconnecting = true; 
      MQTT.connect(); 
    }
  };

  client.onMessageArrived = function (message) {
    var command = JSON.parse(message.payloadString);
    CommandHandler.handle(command, client);
  };
};

setInterval(function () {
  if (client && client.isConnected()) {
    log("MQTT connection is active");
  } else {
    log("MQTT connection lost, trying to reconnect...");
    isReconnecting = true;
    MQTT.connect(); 
  }
}, reconnectInterval);
